VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Image to Icon"
   ClientHeight    =   3150
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2985
   LinkTopic       =   "Form1"
   ScaleHeight     =   210
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   199
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmBpp 
      Caption         =   "Colordepth"
      Height          =   1935
      Left            =   30
      TabIndex        =   4
      Top             =   1140
      Width           =   1815
      Begin VB.OptionButton opBpp 
         Caption         =   "32 Bit Truecolor"
         Height          =   255
         Index           =   5
         Left            =   120
         TabIndex        =   10
         Top             =   1590
         Width           =   1575
      End
      Begin VB.OptionButton opBpp 
         Caption         =   "24 Bit Truecolor"
         Height          =   255
         Index           =   4
         Left            =   120
         TabIndex        =   9
         Top             =   1320
         Width           =   1575
      End
      Begin VB.OptionButton opBpp 
         Caption         =   "16 Bit Truecolor"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   8
         Top             =   1050
         Width           =   1575
      End
      Begin VB.OptionButton opBpp 
         Caption         =   "256 Color"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   7
         Top             =   780
         Value           =   -1  'True
         Width           =   1575
      End
      Begin VB.OptionButton opBpp 
         Caption         =   "16 Color"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   6
         Top             =   510
         Width           =   1575
      End
      Begin VB.OptionButton opBpp 
         Caption         =   "2 Color"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   1575
      End
   End
   Begin VB.CommandButton cmdDraw 
      Caption         =   "Command1"
      Height          =   495
      Left            =   630
      TabIndex        =   0
      Top             =   60
      Width           =   2325
   End
   Begin VB.PictureBox picView 
      AutoRedraw      =   -1  'True
      Height          =   465
      Left            =   30
      ScaleHeight     =   27
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   31
      TabIndex        =   3
      Top             =   600
      Width           =   525
   End
   Begin VB.PictureBox picIco 
      AutoRedraw      =   -1  'True
      Height          =   465
      Left            =   30
      ScaleHeight     =   27
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   31
      TabIndex        =   2
      Top             =   60
      Width           =   525
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Command1"
      Height          =   495
      Left            =   630
      TabIndex        =   1
      Top             =   600
      Width           =   2325
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private eIconFormat As IconFormat

Private Sub cmdDraw_Click()

    ' nun zeichnen wir irgendwas in die
    ' PictureBox in der Gre fr ein 32x32 Icon
    picIco.Line (0, 0)-(31, 31), vbBlue, B
    picIco.Line (5, 5)-(26, 26), vbBlack, B
    picIco.Line (10, 10)-(22, 22), vbRed, BF
    picIco.Line (0, 0)-(32, 32), vbYellow
    picIco.Line (0, 31)-(32, -1), vbMagenta
    picIco.Line (0, 16)-(32, 16), vbGreen
    picIco.Line (16, 0)-(16, 32), vbCyan
    picIco.Line (14, 14)-(18, 18), picIco.BackColor, BF

    ' Button zum speichern aktivieren
    cmdSave.Enabled = True
    
End Sub

Private Sub cmdSave_Click()

    Dim strPath As String
    Dim eIconSize As IconSize
    
    ' Anwendungspfad ermitteln
    strPath = App.Path
    
    ' Backslash anhngen wenn nicht vorhanden
    If Right$(strPath, 1) <> "\" Then
        strPath = strPath & "\"
    End If
    
    ' Dateiname an den Pfad hngen
    strPath = strPath & "testing.ico"
    
    ' Es kann auch ein Bild in die PictureBox geladen bzw. gezeichnet werden.
    ' Allerdings findet hier keine Skalierung des Bildes auf die gewnschte
    ' Icongre statt sondern es wird ein entsprechend groer Ausschnitt aus
    ' dem Bild in ein Icon konvertiert. Entweder man ld schon ein entsprechend
    ' groes Bild in die PictureBox oder man skaliert das Bild voher zb. mit
    ' PaintPicture oder StretchBlt und SetStretchBltMode auf die gewnschte
    ' Gre und zeichnet dieses in die PictureBox.
    
    ' Icongre (Bildausschnitt aus picIco)
    eIconSize = [32x32]
            
    ' ***************************************************************
    ' Unter Windows 95/98/Me muss die PictureBox vorher auf die Gre
    ' des zu erstellenden Icons eingestellt werden.
    ' Ab Windows NT sind diese Zeilen berflssig.
    picIco.Move picIco.Left, picIco.Top, eIconSize, eIconSize
    picIco.Cls
    Call cmdDraw_Click
    ' ***************************************************************
    
    ' nun speichern wir einen 32x32 Pixel groen Ausschnitt aus dem Image
    ' als 32x32 groes Icon im 256 Color-Format wobei die Hintergrundfarbe
    ' der PictureBox als transparente Farbe fr das Icon verwendet werden soll.
    If SaveImageAsIcon(picIco.Image, strPath, eIconSize, eIconFormat, _
        picIco.BackColor, True) Then
        
        ' nach Iconformat selektieren
        Select Case eIconFormat
        
        Case IconFormat.[2 Color], IconFormat.[16 Color], _
            IconFormat.[256 Color], IconFormat.[24 Bit Truecolor]
        
            ' erstelltes Icon zum Test in eine PictureBox laden
            picView.Picture = LoadPicture(strPath)
            
        Case Else
        
            ' VBC kann keine 16bit und 32bit Icons per LoadPicture laden.
            ' Daher verwenden wir hier eine andere Methode um das Icon
            ' in die PictureBox zu laden.
            picView.Picture = LoadIcon(strPath, picView.BackColor)
            
        End Select
        
    Else
    
        ' hier ist dann irgendwas schief gelaufen
        Set picView.Picture = Nothing
        picView.Move cmdDraw.Left + cmdDraw.Width + 4, cmdDraw.Top, 255, 255
        MsgBox "Speichern war nicht erfolgreich."
        
    End If
    
End Sub

Private Sub Form_Load()

    Me.ScaleMode = vbPixels
    Me.Width = 10300
    Me.Height = 4300
    
    eIconFormat = [256 Color]
    
    With picIco
        .BorderStyle = 0
        .ScaleMode = vbPixels
        
        ' PictureBox auf die maximale Standard-Icongre aufziehen
        .Move 2, 2, 256, 256
        
        ' ein muss, sonst geht gar nichts
        .AutoRedraw = True
        
        ' nur damit sich die PictureBox vom Hintergrund der Form abhebt
        .BackColor = QBColor(8)
        
        ' damit wir etwas sehen bleibt die PictureBox sichtbar
        ' .Visible = False
    End With
    
    With cmdDraw
        .Caption = "Draw"
        .Move picIco.Left + picIco.Width + 4, picIco.Top, 155, 30
    End With
    
    With cmdSave
        .Caption = "Save Image as Icon"
        
        .Move picIco.Left + picIco.Width + 4, cmdDraw.Top + cmdDraw.Height + _
            4, 155, 30
        
        .Enabled = False
    End With
    
    With frmBpp
        .Move cmdSave.Left, cmdSave.Top + cmdSave.Height + 4, 155
    End With
    
    With picView
        .AutoSize = True
        .BorderStyle = 0
        .Move cmdDraw.Left + cmdDraw.Width + 4, cmdDraw.Top, 255, 255
        
        ' nur damit wir die transparenten Bereiche des Icons sehen
        .BackColor = QBColor(15)
    End With
    
End Sub

Private Sub opBpp_Click(Index As Integer)

    ' Farbtiefe fr das zu speichernde Icon festlegen
    Select Case Index
    
    Case 0
        eIconFormat = [2 Color]
        
    Case 1
        eIconFormat = [16 Color]
        
    Case 2
        eIconFormat = [256 Color]
        
    Case 3
        eIconFormat = [16 Bit Truecolor]
        
    Case 4
        eIconFormat = [24 Bit Truecolor]
        
    Case 5
        eIconFormat = [32 Bit Truecolor]
        
    End Select
    
End Sub
